;********************************************************************
	LIST P=16F690, b=8, n=97, t=ON, st=OFF
; MPLAB
;Configure->Select Device->16F690
;   b=8,  n=97,    t=ON
;   st=OFF
;==========================================================================
;	Configuration Bits
;==========================================================================
		__CONFIG H'03E9'
;  '__CONFIG'      .asm .
;bit 9-8 BOREN      11 = BOR  (Vbor=2-2,2V)
;bit 7 CPD: Data Code Protect	1 = Data memory code protection is disabled
;bit 6 CP: Code Protection	1 = Program memory code protection is disabled
;bit 5 MCLRE: MCLR Pin Function 1 = MCLR pin function is MCLR 
;bit 4 PWRTE: Power-up Timer 	0 = PWRT enabled  
;-------------
;bit 3 WDTE: Watchdog Timer    	1 = WDT enabled
;bit 2-0			001 = XT oscillator: Crystal/resonator
        IFNDEF __16F690
           MESSG "   .   "
        ENDIF
;
;20-7F - RAM =96  (31_eu)
;0-7FF - ROM (2048) -  0
;800-FFF - ROM (2048) -  1 
;********************************************************************
;*                                               *
;********************************************************************
;w	equ	0
;f	equ	1

RAM	equ	0x00	;"INDF"   
TMR0	equ	0x01	; TMR0
OPT	equ	0x01	;"Bank 1" OPTION
PCL	equ	0x02	; 

STATUS	equ	0x03	;STATUS- 
C	equ	0	;STATUS-CARRY   
Z	equ	2	;STATUS-ZERO -   
RP0	equ	5	;  (  "0")
RP1	equ	6	;  (  "0")

bank0	equ H'00'
bank1	equ H'80'
bank2	equ H'100'
#define BANK_0	BANKSEL bank0 ; bank 0 (BANKSEL -    bsf STATUS,5,6)
#define BANK_1	BANKSEL bank1 ; bank 1 
#define BANK_2	BANKSEL bank2 ; bank 2
#define bank_0	bcf STATUS,RP0 ; "bank 0"  ,  "bank_1"
#define bank_1	bsf STATUS,RP0 ; "bank 1"  ,  "bank_0"
;IRP	equ	7	;  RAM   
;1 =  2, 3 (100h  1FFh)
;0 =  0, 1 (000h - 0FFh)( )

ADR	equ	0x04	;"FSR"   
portA	equ	0x05	;   A
trisA	equ	0x05	;"Bank 1"    A (    0x85  302 )
portB	equ	0x06	;   B
trisB	equ	0x06	;"Bank 1"    B
portC	equ	0x07	;   
trisC	equ	0x07	;"Bank 1"    C
;		equ	0x08	;
PCLatH	equ	0x0A	;   "PCL" ("PCH")
INTCON	equ	0x0B	;"Bank 0-4"  	
PIR1	equ	0x0C	;    !!!!!-"113"
PIE1	equ	0x0C	;"Bank 1"      
TMR1L	equ	0x0E	; TMR1L
TMR1H	equ	0x0F	; TMR1H
T1CON	equ	0x10	; TMR1  ( )
;WPUA	equ	0x15	;"Bank 1"     A
;WPUB	equ	0x15	;"Bank 2"     B
ADRESH	equ	0x1E	; -  
ADRESL	equ	0x1E	;"Bank 1"  -  
ANSEL	equ	0x1E	;"Bank 2"   0-7  (   )
ADCON0	equ	0x1F	;   (.68)
ADCON1	equ	0x1F	;"Bank 1"    
ANSELH	equ	0x1F	;"Bank 2"   8-11  (   )
;****************************************************************
;			RAM
;****************************************************************
TAdr 	equ	0x20	; 

Fkn	equ	0x24	; 
knR	equ	0	;(bit0)  
knU	equ	1	;(bit1) 
knRfOut	equ	2	;(bit2)    
knRf	equ	3	;(bit3)   
knL	equ	4	;(bit4)  
;	equ	5	;(bit5)
knLfOut	equ	6	;(bit6)    
knLf	equ	7	;(bit7)   

FLAG	equ	0x25	;
s0_125	equ	0	;(bit0) 0,125
s0_5	equ	1	;(bit1) 0,5
s1	equ	2	;(bit2) 1
bud	equ	3	;(bit3) 
sig	equ	4	;(bit4) 
;	equ	5	;(bit5)
;	equ	6	;(bit6)
;	equ	7	;(bit7)

DH	equ	0x30	;  
EH	equ	0x31	;  
DM	equ	0x32	;  
EM	equ	0x33	;  
			;4-  "1" -   

DHc	equ	0x34	;  
EHc	equ	0x35	;  
DMc	equ	0x36	;  
EMc	equ	0x37	;  
DHb	equ	0x38	;  
EHb	equ	0x39	;  
DMb	equ	0x3A	;  
EMb	equ	0x3B	;  

POZ	equ	0x3C	;    (0-3)
Pn	equ	0x3D	;
Rejim	equ	0x3E	;  
	;0-
	;1- 
	;2-  
	;3-  
	;4-
	;5-
	;6-
Rn	equ	0x3F	; Rejim

T0_125s	equ	0x40	; 0,125 
T1s	equ	0x41	; 1 
T1m	equ	0x42	; 1 
T0_5s	equ	0x43	; 0,5
Tb	equ	0x44	;    .  4 
Tc	equ	0x45	;    .  4 
MIG	equ	0x46	;- 1-=0,25cek 2-=0,5

LED	equ	0x4F	; 

inA	equ	0x50	;  "A"   
kn	equ	2	;(bit2).17 - 

inAA	equ	0x51	;  "A"   

outA	equ	0x52	;  "A" 

outB	equ	0x55	;  "B"  (bit4-7)
outBB	equ	0x56	;   "B"  (bit4-7)

outC	equ	0x58	;  "C"
			;'76543210'					
			;'EBGFAHCD'
outCC	equ	0x59	;   "C", ( ) 

AN0	equ	0x60	;   
AN1	equ	0x61	;  
AN0S	equ	0x62	;    (AN0)
;----------------    -----------
R0	equ	0x70	; R0
R1	equ	0x71	; R1
R2	equ	0x72	; R2
R3	equ	0x73	; R3

;W_INT		equ	0x7D	;   
;STATUS_INT	equ	0x7E
;PCLatH_INT	equ	0x7F
;####################################################################
	org	0x0000
	goto	RESET_
;##########################   #############################
;  GIE      0  
	org	0x0004

;	movwf	W_INT
;	swapf	STATUS,W
;	clrf	STATUS
;	movwf	STATUS_INT
;	movf	PCLatH,w
;	movwf	PCLatH_INT
;   
;	bcf	PIR1,6	;     ADIF

	btfsc	PIR1,0	;   TMR1  (8-  )
	goto	intTMR1	;
	btfsc	INTCON,2;   TMR0
	goto	intTMR0	;
;----------------------------
END_INT
;	movf	PCLatH_INT,w
;	movwf	PCLatH
;	swapf	STATUS_INT,w
;	movwf	STATUS
;	swapf	W_INT,f
;	swapf	W_INT,w
	retfie ;  GIE    1    .

;###############################   ######################################
;   Win.   timeserver.ru	https://time100.ru/
	org	0x30
k2500	retlw	b'00111011' ;  "343b" b'00111011'    2500 (2,5 )
							; 1,44    (34,56 /)
k24m	retlw	D'60';"343C" {60}       00:00, 1 
k24s	retlw	D'8' ;"3408" {8}     00:00,  0,125  (0,125*8=1)
ir		retlw	D'130' ;"3482"    

;###############################   ######################################
;PIC16F631_677_685_687_689_690_ru .101 -   
;********************************************************************
	org	0x40
RESET_	clrwdt
	bank_1
			
	movlw	b'11010011'	;OPTION_REG 36(en)(   "1") 
		;(bit2,1,0)PS2,PS1,PS0 - . =16
		;(bit3)=0 PSA=0 -    TMR0
		;(bit4)=1 TOSE /    RA2
		;(bit5)=0 TOCS "0"=Internal instruction cycle clock (FOSC/4)
		;(bit6)=1 INTEDG -       RA2
		;(bit7)=1 /RABPU="0"-        A,B ( 29)
	movwf	OPT

;	MOVLW	0x20	; RAM 20-7F  1
;	MOVWF	ADR	
;	CLRW
;RAMC8	MOVWF	RAM
;	INCF	ADR,f
;	BTFSS	ADR,7
;	GOTO	RAMC8
	bank_0
	MOVLW	0x20	; RAM 20-7F  0
	MOVWF	ADR	
	CLRW
RAMC	MOVWF	RAM
	INCF	ADR,f
	BTFSS	ADR,7
	GOTO	RAMC

;**************************   ******************************************
	movlw	D'50'
	movwf	T0_125s
	movlw	D'4'
	movwf	T0_5s
	movlw	D'8'
	movwf	T1s
	movlw	D'60'
	movwf	T1m
	movlw	D'16'
	movwf	Tb	; 4      ..
	movwf	Tc	; 4      ..
	movlw	D'4'	;.  
	movwf	POZ
	movlw	D'8'	;  "bAtt"
	movwf	Rejim
	clrf	TMR0	; 
	movlw	b'00111011' ;  2500 =  2,5 
	movwf	TMR1L
	movlw	b'11110110'
	movwf	TMR1H
	movlw	b'00000001' ; TMR1,  1:1
	movwf	T1CON	
	clrwdt		;  
;********************************************************************
;*       /	                            *
;********************************************************************
	movlw	b'00000000'	;  A
	movwf	portA

	movlw	b'00000000'	;  B
	movwf	portB

	movlw	b'11111111'	;  C
	movwf	portC

	BANK_2
	movlw	b'00000011'
	movwf	ANSEL 		; I/O
	CLRF	ANSELH
	;WPUB     B (   RABPU  OPTION)

	BANK_1
	movlw	b'11111111'	;  a A ("1"-,"0"-)
	movwf	trisA		; "--11 1111" -  
	movlw	b'00000000'	;   B ("1"-,"0"-)
	movwf	trisB		; "1111 ----" -  
	movlw	b'00000000'	;   C ("1"-,"0"-)
	movwf	trisC		; "1111 1111" -  
	;WPUA     A (   RABPU  OPTION)
	movlw	b'01010000'	;    (101 = Fosc/16 = 4us) 4us*11=44us -  
	movwf	ADCON1		; "--11 1111" -  
	bsf	PIE1,0		;   TMR1	

	bank_0
	movlw	b'11100000'	;   TMR0   (TMR1)
	movwf	INTCON		;
	goto	START
;############################  TMR1 ##################################
intTMR1	;9-  
;	nop	;     
;-----------------
; ,   2,5  (*4=10=100), =1
;(2501/2500-1)*3600 = 1,44    (34,56 /)
;11110110_00111011   2500 =  2,5 
;	movlw	b'00111110'
	call	k2500	;   2500 ;00111110=100,004Hz

	addwf	TMR1L,f	;11-(+10) ,  	
	movlw	b'11110110'
	movwf	TMR1H	;   
	bcf	PIR1,0	;    TMR1 PIR1,0
	clrwdt		;  

	movf LED,w	; 
			; ,    
			; = 1  = 256*5=1280   256-5="251"
			;"248"=2,07 
	movwf TMR0	;    
	bcf INTCON,2	;    TMR0     (  )
;-------------------------------------------------
	movf	inA,w
	movwf	inAA	;  A   
	movf	portA,w	
	movwf	inA	;  A

	clrf	portB	;  c  

	movf	outC,w
	movwf	outCC
	movwf	portC	;   C ()

	movf	outB,w	
	movwf	outBB	
	movwf	portB	;   B ()

	bcf	Fkn,knLf
	btfsc	Fkn,knLfOut
	bsf	Fkn,knLf ;    
	bcf	Fkn,knLfOut

	bcf	Fkn,knRf
	btfsc	Fkn,knRfOut
	bsf	Fkn,knRf ;    
	bcf	Fkn,knRfOut
;*********************************************************************
;clock			
;*********************************************************************
	bcf	FLAG,s0_125
	bcf	FLAG,s0_5
	bcf	FLAG,s1

	decfsz	T0_125s,f
	goto	cEND
	movlw	D'50'		;2,5*50=0,125
	movwf	T0_125s		
	bsf	FLAG,s0_125	; 0,125 

	incf	MIG,f		; 1-=0,25cek 2-=0,5

	decfsz	T0_5s,f
	goto	c1
	bsf	FLAG,s0_5	; 0,5
	movlw	D'4'
	movwf	T0_5s
c1
	decfsz	T1s,f
	goto	cEND
	movlw	D'8'
	movwf	T1s
	bsf	FLAG,s1	; 1 

	decfsz	T1m,f	; 
	goto	cEND
	movlw	D'60'
	movwf	T1m

	bsf	FLAG,sig ; 
;*****************************
	incf	EMc,f	; 
	movlw	D'10'
	subwf	EMc,w
	btfss	STATUS,Z	
	goto	cEND	; 
	clrf	EMc

	incf	DMc,f	; 
	movlw	D'6'
	subwf	DMc,w
	btfss	STATUS,Z	
	goto	cEND	; 
	clrf	DMc

	incf	EHc,f	; 
	movlw	D'10'
	btfsc	DHc,1	; =2
	movlw	D'4'
	subwf	EHc,w
	btfss	STATUS,Z
	goto	cEND	; 
	clrf	EHc	; EHc  24  11  

	incf	DHc,f	; 
	movlw	D'3'
	subwf	DHc,w
	btfss	STATUS,Z
	goto	cEND
	clrf	DHc	; 
; 
	call	k24m;      00:00 
	movwf	T1m ; 1 
	call	k24s;   (0,125*8=1)
	movwf	T1s ; 0,125 
cEND
	btfss	FLAG,bud	; 
	bcf	FLAG,sig
	movf	DHb,w
	subwf	DHc,w
	btfss	STATUS,Z		
	bcf	FLAG,sig
	movf	EHb,w
	subwf	EHc,w
	btfss	STATUS,Z		
	bcf	FLAG,sig
	movf	DMb,w
	subwf	DMc,w
	btfss	STATUS,Z		
	bcf	FLAG,sig
	movf	EMb,w
	subwf	EMc,w
	btfss	STATUS,Z		
	bcf	FLAG,sig
;*********************************************************************
;	
;*********************************************************************
	incf	Rejim,w
	movwf	Rn		;Rn=Rejim+1

n1	decfsz	Rn,f	;  
	goto	n2

	movf	DHc,w
	btfsc	STATUS,Z
	movlw	0x0F	; 
	movwf	DH
	movf	EHc,w
	movwf	EH
	btfsc	MIG,2	; 1-=0,25cek 2-=0,5
	bsf	EH,4	;  
	movf	DMc,w
	movwf	DM
	btfss	MIG,2	; 1-=0,25cek 2-=0,5
	bsf	DM,4	;  
	movf	EMc,w
	movwf	EM
	btfsc	FLAG,sig
	bsf	EM,4	; 
	btfss	MIG,2	; 1-=0,25cek 2-=0,5
	bcf	EM,4

	btfsc	Fkn,knL	;     
	bcf	FLAG,sig
	btfsc	Fkn,knR
	bcf	FLAG,sig
	movlw	D'55'	;T1m     60-55=5
	subwf	T1m,w
	btfsc	STATUS,C
	goto	n1_2
	call	ir	;  
	subwf	AN0S,w
	btfsc	STATUS,C ;    
	bcf	FLAG,sig
n1_2
	movlw	D'32'
	btfsc	Fkn,knLf;    
	movwf	Tc	; 4      .

	btfss	Fkn,knL
	goto	n1_1
	btfss	FLAG,s0_125
	goto	nEND
	decfsz	Tc,f	; 4      .
	goto	nEND
	movlw	D'5'	;n6- . (Rejim=n+1)
	movwf	Rejim
	goto	nEND
n1_1
	movlw	D'32'
	movwf	Tb	; 4      ..

	btfsc	Fkn,knRf ;    
	incf	Rejim,f	
	goto	nEND
	
n2	decfsz	Rn,f	;  
	goto	n3

	btfss	Fkn,knR
	clrf	Rejim	;  ,     .

	clrf	R0
	bsf	R0,bud
	btfss	Fkn,knR
	bcf	R0,bud
	btfss	Fkn,knLf;    
	bcf	R0,bud
	movf	R0,w
	xorwf	FLAG,f	;/ 

	movf	EMb,w
	movwf	EM
	movf	DMb,w
	movwf	DM
	bsf	DM,4	; 
	movf	EHb,w
	movwf	EH
	bsf	EH,4	; 
	movf	DHb,w
	movwf	DH

	btfss	FLAG,s0_125
	goto	nEND
	decfsz	Tb,f	; 4      ..
	goto	nEND
	incf	Rejim,f	; .
	goto	nEND

n3	decfsz	Rn,f	; .
	goto	n4

	bsf		FLAG,bud ; 

	movf	DHb,w	;  DHb  
	btfsc	MIG,1	; 1-=0,25cek 2-=0,5
	movlw	0x0F	;
	movwf	DH
	movf	EHb,w	;  EHb  
	btfsc	MIG,1	; 1-=0,25cek 2-=0,5
	movlw	0x0F	;
	movwf	EH
	bsf	EH,4	; 

	movf	DMb,w	;  DMb  
	movwf	DM
	bsf	DM,4	; 
	movf	EMb,w	;  EMb  
	movwf	EM

	btfss	Fkn,knR	;  
	incf	Rejim,f	; .
	goto	nEND

n4	decfsz	Rn,f	; .. 
	goto	n5

	btfsc	Fkn,knLf ;    
	incf	Rejim,f	; . 

	movf	DHb,w	;  DHb  
	btfsc	MIG,1	; 1-=0,25cek 2-=0,5
	movlw	0x0F	;
	movwf	DH
	movf	EHb,w	;  EHb  
	btfsc	MIG,1	; 1-=0,25cek 2-=0,5
	movlw	0x0F	;
	movwf	EH
	bsf	EH,4	; 

	btfss	Fkn,knR
	goto	nEND	;  
	btfss	FLAG,s0_5 ; 0,5 
	goto	nEND

	incf	EHb,f
	movlw	D'10'
	btfsc	DHb,1	; =2
	movlw	D'4'
	subwf	EHb,w
	btfss	STATUS,Z
	goto	nEND	; 
	clrf	EHb

	incf	DHb,f
	movlw	D'3'
	subwf	DHb,w
	btfsc	STATUS,Z
	clrf	DHb

	goto	nEND

n5	decfsz	Rn,f	; .. 
	goto	n6

	btfsc	Fkn,knLf;    
	clrf	Rejim	; 

	movf	DHb,w	;  DHb  
	movwf	DH
	movf	EHb,w	;  EHb  
	movwf	EH
	bsf	EH,4	; 

	movf	DMb,w	;  DMb  
	btfsc	MIG,1	; 1-=0,25cek 2-=0,5
	movlw	0x0F	;
	movwf	DM
	bsf	DM,4	; 
	movf	EMb,w	;  EMb  
	btfsc	MIG,1	; 1-=0,25cek 2-=0,5
	movlw	0x0F	;
	movwf	EM

	btfss	Fkn,knR
	goto	nEND	;  
	btfss	FLAG,s0_5 ; 0,5 
	goto	nEND

	incf	EMb,f
	movlw	D'10'
	subwf	EMb,w
	btfss	STATUS,Z	
	goto	nEND	; 
	clrf	EMb

	incf	DMb,f
	movlw	D'6'
	subwf	DMb,w
	btfsc	STATUS,Z	
	clrf	DMb

	goto	nEND
; 
n6	decfsz	Rn,f	; 
	goto	n7

	btfss	Fkn,knL	;  
	incf	Rejim,f	; . 

	movf	DHc,w	;  DHc  
	btfsc	MIG,1	; 1-=0,25cek 2-=0,5
	movlw	0x0F	;
	movwf	DH
	movf	EHc,w	;  EHc  
	btfsc	MIG,1	; 1-=0,25cek 2-=0,5
	movlw	0x0F	;
	movwf	EH
	bsf	EH,4	; 

	movf	DMc,w	;  DMc  
	movwf	DM
	bsf	DM,4	; 
	movf	EMc,w	;  EMc  
	movwf	EM

	goto	nEND

n7	decfsz	Rn,f	; .
	goto	n8

	btfsc	Fkn,knLf ;    
	incf	Rejim,f	; .

	movf	DHc,w	;  DHc  
	btfsc	MIG,1	; 1-=0,25cek 2-=0,5
	movlw	0x0F	;
	movwf	DH
	movf	EHc,w	;  EHc  
	btfsc	MIG,1	; 1-=0,25cek 2-=0,5
	movlw	0x0F	;
	movwf	EH
	bsf	EH,4	; 

	btfss	Fkn,knR
	goto	nEND	;  
	btfss	FLAG,s0_5 ; 0,5 
	goto	nEND

	incf	EHc,f
	movlw	D'10'
	btfsc	DHc,1	; =2
	movlw	D'4'
	subwf	EHc,w
	btfss	STATUS,Z
	goto	nEND	; 
	clrf	EHc

	incf	DHc,f
	movlw	D'3'
	subwf	DHc,w
	btfsc	STATUS,Z
	clrf	DHc

	goto	nEND

n8	decfsz	Rn,f	; .
	goto	n9
	
	btfsc	Fkn,knLf ;    
	clrf	Rejim	; 

	movf	DHc,w	;  DHc  
	movwf	DH
	movf	EHc,w	;  EHc  
	movwf	EH
	bsf	EH,4	; 

	movf	DMc,w	;  DMc  
	btfsc	MIG,1	; 1-=0,25cek 2-=0,5
	movlw	0x0F	;
	movwf	DM
	bsf	DM,4	; 
	movf	EMc,w	;  EMc  
	btfsc	MIG,1	; 1-=0,25cek 2-=0,5
	movlw	0x0F	;
	movwf	EM

	movlw	D'60'
	movwf	T1m	; 

	btfss	Fkn,knR
	goto	nEND	;  
	btfss	FLAG,s0_5 ; 0,5 
	goto	nEND

	incf	EMc,f
	movlw	D'10'
	subwf	EMc,w
	btfss	STATUS,Z	
	goto	nEND	; 
	clrf	EMc

	incf	DMc,f
	movlw	D'6'
	subwf	DMc,w
	btfsc	STATUS,Z	
	clrf	DMc

	goto	nEND
;  bAtt
n9 	btfsc	Fkn,knLf ;    
	clrf	Rejim	; 

	movlw	0x0b	;"b"
	movwf	DH
	movlw	0x0a	;"A"
	movwf	EH
	movlw	0x0c	;"t"
	movwf	DM
	movlw	0x0c	;"t"
	movwf	EM
nEND
;*********************************************************************
;	, , , , 
;    (poz4=)  . poz4,3,2,1,4...
;*********************************************************************
	decf	POZ,f	;  
	movlw	4
	btfsc	STATUS,Z
	movwf	POZ
	movf	POZ,w
	movwf	Pn
		
poz1	decfsz	Pn,f	;
	goto	poz2
	movlw	b'00010000'	; 
	movwf	outB

	bcf	Fkn,knLfOut
	btfsc	Fkn,knL		; 
	goto	poz11
	btfsc	inA,kn		; 
	bsf	Fkn,knLfOut	;    
poz11
	bcf	Fkn,knL		
	btfsc	inA,kn	
	bsf	Fkn,knL		;  

	movf	ADRESH,w	;3-  AN1().   
	movwf	AN1

	clrf	LED
	btfss	Fkn,knU	;     
	goto	poz12

	movf	AN1,w	;    
	movwf	LED
poz12	comf	LED,f	;    

	movlw	b'00000001'	;1-  AN0.   ,  , .68
	movwf	ADCON0		; 

	btfsc	FLAG,bud
	bsf	DH,4	; 

	call	ir	;   
	subwf	AN0S,w	;  
	btfsc	STATUS,C
	bcf	DH,4	;  -  

	movf	DH,w	; 
	goto	poz

poz2	decfsz	Pn,f
	goto	poz3
	movlw	b'00100000';
	movwf	outB

	bcf	Fkn,knRfOut
	btfsc	Fkn,knR	; 
	goto	poz21
	btfsc	inA,kn	; 
	bsf	Fkn,knRfOut ;    
poz21
	bcf	Fkn,knR		
	btfsc	inA,kn	
	bsf	Fkn,knR	;  

	bsf	ADCON0,1 ;2-  AN1.   (.68)

	movf	EH,w
	goto	poz

poz3	decfsz	Pn,f
	goto	poz4
	movlw	b'01000000' ;
	movwf	outB

	bcf	Fkn,knU	;  
	btfsc	inA,kn	
	bsf	Fkn,knU

	movf	ADRESH,w ;3-  AN0.   
	movwf	AN0	;  "FF" -  
	comf	AN0,w	;"00"= 
	addwf	AN0S,f	; 
	movlw	D'15'	; 
	subwf	AN0S,f
	btfss	STATUS,C ;    
	clrf	AN0S
	
	movlw	b'00000101' ;1-  AN1.    (.68)
	movwf	ADCON0	;

	movf	DM,w
	goto	poz

poz4	movlw	b'10000000' ; 
	movwf	outB

	bsf	ADCON0,1;2-  AN0.   (.68)  

	movf	EM,w
;	movf	AN0,w	; 
;	movf	AN1,w	; 

poz	andlw	0x1F	;   
	movwf	TAdr	;  
	call	MData	;W= 
	movwf	outC
	comf	outC,f	;   

	goto	END_INT	
;#########################  TMR0 #####################
intTMR0	bcf INTCON,2	;    TMR0
;********************* (=2,5)****************
	movlw	b'11111111'
	movwf	R1
	btfss	outBB,7	; EM () 
	goto	t1
	btfss	outCC,2	;,  (h)
	bcf	R1,2	;   
t1	movf	R1,w
	movwf	portC

	goto	END_INT	
;###########################   ######################
START	nop	;  
	goto	START
;###################################################################

;_______________
;*************  TAdr-  w-  *******************
MData	movlw   high M256
		movwf   PCLatH
		movf    TAdr,w
		addlw   low M256
		btfsc   STATUS,C ;        
		incf    PCLatH,f ;( 256 Word)
		movf    TAdr,w
		addwf   PCL,f

			;'EBGFAHCD'
M256		retlw	b'11011011'	;"0"	 AAA 
		retlw	b'01000010'	;"1"	F   B
		retlw	b'11101001'	;"2"	F   B
		retlw	b'01101011'	;"3"	F   B
		retlw	b'01110010'	;"4"	 GGG 
		retlw	b'00111011'	;"5"	E   C
		retlw	b'10111011'	;"6"	E   C
		retlw	b'01001010'	;"7"	E   C
		retlw	b'11111011'	;"8"	 DDD H
		retlw	b'01111011'	;"9"	
		retlw	b'11111010'	;"A"
		retlw	b'10110011'	;"b"
		retlw	b'10110001'	;"t"
		retlw	b'11100011'	;"d"
		retlw	b'10111001'	;"E"
		retlw	b'00000000'	;" "

		retlw	b'11011111'	;"0."	 AAA 
		retlw	b'01000110'	;"1."	F   B
		retlw	b'11101101'	;"2."	F   B
		retlw	b'01101111'	;"3."	F   B
		retlw	b'01110110'	;"4."	 GGG 
		retlw	b'00111111'	;"5."	E   C
		retlw	b'10111111'	;"6."	E   C
		retlw	b'01001110'	;"7."	E   C
		retlw	b'11111111'	;"8."	 DDD H
		retlw	b'01111111'	;"9."	
		retlw	b'11111110'	;"A."
		retlw	b'10110111'	;"b."
		retlw	b'10110101'	;"t."
		retlw	b'11100111'	;"d."
		retlw	b'10111101'	;"E."
		retlw	b'00000100'	;" ."
			;'EBGFAHCD'
;********************************************************************
progEND	
		end
;  -  
;   5  - . 
;   .  
;  -  
;   5  - . 
;       ,   - / 
;      -  


